package ch.rolfp.mgrechner;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

//public class MainActivity extends Activity implements OnClickListener, AdapterView.OnItemSelectedListener {
public class MainActivity extends Activity implements OnClickListener {

    private static String eingegebeneFormel="";
    private static boolean needsRecalc=false;
    TextView textOutput;
    TextView textOutput2,textOutput3,textOutput4;
    TextView textOutput5,textOutput6,textOutput7;
    private static Button buttonCalc;
    static int helpflag=0;
    private static String undoString="";


    public static void setEingegebeneFormel(String formel) {
        eingegebeneFormel = formel;
        needsRecalc = true;
    }
    public static String getEingegebeneFormel() {
        return eingegebeneFormel;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        buttonCalc=(Button)findViewById(R.id.buttonCalc);
        buttonCalc.setOnClickListener(this);
        Button buttonClr=(Button)findViewById(R.id.buttonClr);
        buttonClr.setOnClickListener(this);
        Button button3=(Button)findViewById(R.id.buttonTilde);
        button3.setOnClickListener(this);
        Button button4=(Button)findViewById(R.id.buttonHelp);
        button4.setOnClickListener(this);
        Button button5=(Button)findViewById(R.id.buttonReactions);
        button5.setOnClickListener(this);
        (findViewById(R.id.buttonMenu)).setOnClickListener(this);
        (findViewById(R.id.editText)).setOnClickListener(this);

        textOutput = (TextView) findViewById(R.id.textViewResultAverage);
        textOutput2 = (TextView) findViewById(R.id.textViewResultIsotop);
        textOutput3 = (TextView) findViewById(R.id.textView6);
        textOutput4 = (TextView) findViewById(R.id.textView7);
        textOutput5 = (TextView) findViewById(R.id.textView9); //Feld fuer NormierteFormel
        textOutput6 = (TextView) findViewById(R.id.textView10); //Feld fuer SummenFormel
        textOutput7 = (TextView) findViewById(R.id.textView11);

        /*
        Spinner spinner = (Spinner)findViewById(R.id.spinnerExamples);
        ArrayAdapter adapter=ArrayAdapter.createFromResource(this,R.array.beispielFormeln,android.R.layout.simple_spinner_item);
        spinner.setAdapter(adapter);
        spinner.setOnItemSelectedListener(this);
        */
    }

    /*
    @Override
    public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        EditText editText = (EditText) findViewById(R.id.editText);
        if(position>0) editText.setText(beispielFormeln[position-1]);
    }
    final static String[] beispielFormeln = {
            "ClCH2-CO-NH-C6H2Cl2-N=N-C6H2Cl2-NH-CO-CH2Cl",
            "H~KETAACKFERQHMDCSTSAA~OH"
    };
    @Override
    public void onNothingSelected(AdapterView<?> parent) {
    }
    */

    private void buttonCalcDark() {
        buttonCalc.setBackgroundColor(getResources().getColor(R.color.accent));
    }
    private void buttonCalcLight() {
        buttonCalc.setBackgroundColor(getResources().getColor(R.color.accent_light));
    }

    @Override
    public void onClick(View v) {
        double mg=0, mg2=0;
        int showflag=0;
        EditText editText = (EditText) findViewById(R.id.editText);
        switch (v.getId()) {
            case R.id.buttonCalc:
                buttonCalcDark();
                mg = calculate_mol_weight(editText.getText().toString(), false);
                mg2 = calculate_mol_weight(editText.getText().toString(), true);
                showflag = 1;
                buttonCalcLight();
                break;
            case R.id.buttonClr:
                String string=editText.getText().toString();
                if(string.length()==0) editText.setText(undoString);
                else {editText.setText(""); undoString=string;}
                error_reset(null, null);
                showflag = 1;
                break;
            case R.id.buttonTilde:
                //editText.setText(editText.getText().toString() + "~");
                int cursorpos = editText.getSelectionStart();
                int cursorpos2 = editText.getSelectionEnd();
                String str = editText.getText().toString();
                String newstring = str.substring(0, cursorpos) + "~" + str.substring(cursorpos2, str.length());
                editText.setText(newstring);
                editText.setSelection(cursorpos2 + 1);
                buttonCalcDark();
                break;
            case R.id.buttonMenu:
                eingegebeneFormel = editText.getText().toString();
                startActivity(new Intent(this, MyMenuActivity.class));
                break;
            case R.id.buttonHelp:
                if (helpflag == 0) textOutput7.setText(R.string.helptext2);
                else if (helpflag == 1) textOutput7.setText(R.string.helptext3);
                else if (helpflag == 2) textOutput7.setText(R.string.helptext4);
                else if (helpflag == 3) textOutput7.setText(R.string.helptext5);
                else if (helpflag == 4) textOutput7.setText(R.string.helptext6);
                else if (helpflag == 5) textOutput7.setText(R.string.examples);
                if (++helpflag == 6) helpflag = 0;
                break;
            case R.id.buttonReactions:
                eingegebeneFormel = editText.getText().toString();
                startActivity(new Intent(this,ReactionsActivity.class));
                break;
            case R.id.editText:
                buttonCalcDark();
                break;
            default:
        }
        if(showflag!=0) {
            //textOutput.setText(Double.toString(round4(mg)));
            textOutput.setText(String.format("%.4f", mg));
            //textOutput2.setText(Double.toString(round4(mg2)));
            textOutput2.setText(String.format("%.4f", mg2));
            if (warnflag != 0) textOutput3.setText(warningstring);
            else textOutput3.setText("");
            if (errorflag != 0) textOutput4.setText(errorstring);
            else textOutput4.setText("");
            textOutput5.setText(textNormierteFormel);
            textOutput6.setText(textSummenFormel);
        }

    }

    @Override
    protected void onResume() {
        super.onResume();
        if(needsRecalc) {
            buttonCalcDark();
            EditText editText = (EditText) findViewById(R.id.editText);
            editText.setText(eingegebeneFormel);
            onClick(findViewById(R.id.buttonCalc));
            needsRecalc=false;
        }
    }

    @Override
    protected void onPause() {
        if(eingegebeneFormel.length()>0) needsRecalc=true;
        super.onPause();
    }

static String textNormierteFormel;
static String textSummenFormel;

//static double round4(double x) {return java.lang.Math.round(x*1e4)/1e4;}

static double calculate_mol_weight(String formel,boolean isoflag)
{
 String s[]={null}; //Zeiger auf einen String
 double result=0;
 int n;
 error_reset(null,null);
 formel += "\0";
 if(!isoflag) {  //einmal machen reicht
   textNormierteFormel=formel_normieren(formel, formel.length());
   textSummenFormel = getsummenformel(textNormierteFormel,null);
 }
 n=klammertest(textNormierteFormel);
 if(n<0)
  fehler1("fehlende Klammer auf");
 else if(n>0)
  fehler1("fehlende Klammer zu");
 else
  {
   result=mol_weight(textNormierteFormel,s,isoflag?1:0);
   if(actinium_warnung>0) warnung1("Hinweis: Ac = Actinium, Ace = Acetyl");
  }
 return result;
}

static int klammertest(String text)
{
 int k1=0,k2=0,c,i;
 for(i=0;(c=text.charAt(i))!=0;i++)
   {
    if(c=='(') k1++; else if(c==')') --k1;
    else if(c=='[') k2++; else if(c==']') --k2;
   }
 if(k1!=0) return k1;
 return k2;
}

static boolean isupper(int c) {return c>='A' && c<='Z';}
static boolean islower(int c) {return c>='a' && c<='z';}
static boolean isdigit(int c) {return c>='0' && c<='9';}

static boolean isfirstformelzeichen(int c)
{
 return (isupper(c) || c=='(' || c=='[' || c=='^');
}

static boolean ist_leer(int c)
{
 return (c=='-' || c=='=' || c=='_');
}

static boolean isformelzeichen(int c)
{
 return (isfirstformelzeichen(c) || islower(c) || ist_leer(c)
	 || c==')' || c==']');
}

static final String aminos[]=
 {
  "Ala", //'A'
  "Aib", //'B'
  "Cys", //'C'
  "Asp", //'D'
  "Glu", //'E'
  "Phe", //'F'
  "Gly", //'G'
  "His", //H
  "Ile", //I
  "Aha", //J
  "Lys", //K
  "Leu", //L
  "Met", //M
  "Asn", //N
  "Oxx", //O
  "Pro", //P
  "Gln", //Q
  "Arg", //R
  "Ser", //S
  "Thr", //T
  "Uxx", //U
  "Val", //V
  "Trp", //W
  "Xxx", //'X' 
  "Tyr", //'Y'
  "Zxx", //'Z'
  null
 };

// Tabelle fuer Summenformeln-Berechnung:
static final String aminos_summenformel[]=
 {
  "C3H5NO", //'A'
  "C4H7NO", //'B'
  "C3H5NOS", //'C'
  "C4H5NO3", //'D'
  "C5H7NO3", //'E'
  "C9H9NO", //'F'
  "C2H3NO", //'G'
  "C6H7N3O", //H
  "C6H11NO", //I
  "C4H6N4O", //J
  "C6H12N2O", //K
  "C6H11NO", //L
  "C5H9NOS", //M
  "C4H6N2O2", //N
  "\0", //O
  "C5H7NO", //P
  "C5H8N2O2", //Q
  "C6H12N4O", //R
  "C3H5NO2", //S
  "C4H7NO2", //T
  "\0", //U
  "C5H9NO", //V
  "C11H10N2O", //W
  "\0",        //'X' 
  "C9H9NO2", //'Y'
  "\0",      //'Z'
  null
 };

/*
static String einbuchstaben_auf_dreibuchstaben_abkuerzung_erweitern(int c)
{
 return aminos[c-'A']+"\0";
}
*/

/*
static int dreibuchstaben_auf_einbuchstaben_abkuerzung_reduzieren(String peptid)
{
 int c;
 for(c='A';c<='Z';c++)
  {
   //if(peptid==aminos[c-'A']) return c; //== ersetzen durch .equals oder durch strcmp() ?
   //if(peptid.equals(aminos[c-'A'])) return c;
   if(strcmp(peptid,aminos[c-'A'])==0) return c;
  }
 return 0;
}
*/

static String formel_normieren(String quelle,int imax)
{
 /* Sonderzeichen ~ zum Umschalten auf Kurzschreibweise von Peptidketten
    werden hier entfernt und die Peptide auf die 3-Buchstabenschreibweise
    erweitert. Zudem noch allfaellige Leerzeichen entfernt.
 */
 String ziel="";
 final int kette=1;
 int i,modus=0;
 char c;
 //System.out.println("formel_normieren('"+quelle+"',"+imax+")"); //test
  if(nextchar(quelle)=='~') ziel += "H"; //Peptid automatisch mit H beginnen lassen
 for(i=0;i<imax && (c=quelle.charAt(i))!=0;i++)
   {
    if((c & 0x80)!=0) {fehler0("Sonderzeichen ignoriert",c);}
    else if(c=='~')
        {
            modus=kette-modus; ziel += '-';
            if(quelle.charAt(i+1)==0) ziel += "OH"; //Peptidkette automatisch mit OH enden lassen
        }
    else if(c==' ' || c=='\n' || c=='\t') ;//Leerzeichen entfernen
    else if(modus==kette)
     {
      if(c>='A' && c<='Z') {ziel += aminos[c-'A'];}
      else {ziel += c;}
     }
    else /*if(modus==normal)*/
      {ziel += c;}
   }
 ziel += "\0";
 //System.out.println("return '"+ziel+"'"); //test
 return ziel;
}

//struct _mgtab {const char *symbol; double wert;};
//typedef struct _mgtab mgtab;
/* dies funktioniert nicht:
class mgtab {
    String symbol;
    double wert;
    public mgtab(String s,double w)
        {symbol=s; wert=w;}
};
*/

// auf 2 Tabellen aufgeteilt. So elegant wie in c geht es leider nicht.
final static String mgtabelleSymbol[] = 
{
 "Ace", //Acethyl (H3C-C=O)
 "Ac", //Actinium
 "Ag",
 "Ala",
 "Al",
 "Aib",
 "Aha",
 "Arg",
 "Ar",
 "Asn",
 "Asp",
 "As",
 "Am",
 "At",
 "Au",
 "Ba",
 "Be",
 "Bi",
 "Bk",
 "Br",
 "Boc",
 "Bzl",
 "Bu", // Butyl
 "Ca",
 "Cd",
 "Ce",
 "Cf",
 "Cl",
 "Cm",
 "Cp", // Cyclopentadienyl (C5H5)
 "Cr",
 "Cs",
 "Co",
 "Cu",
 "Cys",
 "Dy",
 "Er",
 "Es",
 "Et", // Ethyl
 "Eu",
 "Fe",
 "Fmoc", //Fmoc-Schutzgruppe
 "Fm",
 "Fr",
 "Ga",
 "Gd",
 "Ge",
 "Gly",
 "Gln",
 "Glu",
 "He",
 "Hf",
 "Hg",
 "Ho",
 "His",
 "Ile",
 "In",
 "Ir",
 "Kr",
 "La",
 "Li",
 "Lr",
 "Lu",
 "Leu",
 "Lys",
 "Md",
 "Met", //Methionin
 "Me", //Methyl
 "Mg",
 "Mn",
 "Mo",
 "Mz", //Mz-Schutzgruppe
 "MZ", //Mz-Schutzgruppe
 "Na",
 "Nb",
 "Nd",
 "Ne",
 "Ni",
 "No",
 "Np",
 "Os",
 "Pa",
 "Pbf", //Pbf-Schutzgruppe
 "Pb",
 "Pd",
 "Phe", //Phenylalanin
 "Ph", //Phenyl (C6H5)
 "Pm",
 "Po", //Polonium
 "Pro", //Prolin
 "Pr", //Praseodym (Praseodymium)
 "Pt",
 "Pu",
 "Pz", //Pz-Schutzgruppe
 "PZ", //Pz-Schutzgruppe
 "Ra",
 "Rb",
 "Re",
 "Rh",
 "Rn",
 "Ru",
 "Sb",
 "Sc",
 "Ser", //Serin
 "Se", //Selen
 "Si",
 "Sm",
 "Sn",
 "Sr",
 "Ta",
 "Tb",
 "Tc",
 "Te",
 "Thr", //Threonin
 "Th", //Thorium
 "Ti",
 "Tl",
 "Tm",
 "Trp", //Tryptophan
 "Tyr", //Tyrosin
 "Val", //Valin
 "Xe",
 "Yb",
 "Zn",
 "Zr",
 //kuenstliche Elemente:
 "Rf", //Rutherfordium, (61sec Halbwertszeit)
 "Db", //Dubnium, 262 (34sec), 263 (27sec), 261 (1.8sec)
 "Sg", //Seaborgium
 "Bh", //Bohrium
 "Hs", //Hassium, 265(1.5ms), 269(10s), 270 (22s)
 "Mt", //Meitnerium, 2 Isotope 266 (3.4ms) und 268 (70ms Halbwertszeit)
 "Ds", //Darmstadtium, 6 Isotope zwischen 269 (0.18ms) und 281 (66s)
 "Rg", //Roentgenium, 6 Isotope, 272 (3.8ms) bis 280 (3.6s)
 "Cn", //Copernicium, 3 Isotope, 277 (0.2ms), 283 (4s), 285 (34s)
    //hier koennen noch weitere Abkuerzungen eingefuegt werden
  null
};
final static double mgtabelleWert[] =
  {
   43.04522, //Acethyl (H3C-C=O)
   227.0278, //Actinium
   107.8682,
   71.0788,
   26.9815, //Aluminium
   85.10568,
   126.11784,
   156.18748,
   39.948,
   114.10384,
   115.08860,
   74.9216,
   243.0614,
   209.9871,
   196.9665,
   137.327,
   9.01218,
   208.9804,
   247.0703,
   79.909,
   101.12526,
   91.13258,
   57.11546, // Butyl
   40.078,
   112.411,
   140.115,
   251.0796,
   35.453,
   247.0703,
   65.0947, // Cyclopentadienyl (C5H5)
   51.9961,
   132.9051,
   58.9332,
   63.546,
   103.14480,
   162.5,
   167.26,
   252.0829,
   29.06170, // Ethyl
   151.965,
   55.847,
   223.25114, //Fmoc-Schutzgruppe
   257.0951,
   223.0197,
   69.723,
   157.25,
   72.61,
   57.05192,
   128.13072,
   129.11548,
   4.002602,
   178.49,
   200.59,
   164.9303,
   137.14108,
   113.15944,
   114.82,
   192.22,
   83.80,
   138.9055,
   6.941,
   260.1053,
   174.967,
   113.15944,
   128.17408,
   258.0986,
   131.19856, //Methionin
   15.03482, //Methyl
   24.305,
   54.938,
   95.94,
   269.27982, //Mz-Schutzgruppe
   269.27982, //Mz-Schutzgruppe
   22.9897,
   92.90638,
   144.24,
   20.1797,
   58.69,
   259.1009,
   237.0482,
   190.2,
   231.0359,
   253.34218, //Pbf-Schutzgruppe
   207.2,
   106.42,
   147.17656, //Phenylalanin
   77.10570, //Phenyl (C6H5)
   146.9151,
   208.9824, //Polonium
   97.11668, //Prolin
   140.9077, //Praseodym (Praseodymium)
   195.08,
   244.0642,
   239.25354, //Pz-Schutzgruppe
   239.25354, //Pz-Schutzgruppe
   226.0254,
   85.4678,
   186.207,
   102.9055,
   222.0176,
   101.07,
   121.75,
   44.95591,
   87.07820, //Serin
   78.96  , //Selen
   28.0855,
   150.36,
   118.710,
   87.62,
   180.9479,
   158.9253,
   98.9063,
   127.60,
   101.10508, //Threonin
   232.0381, //Thorium
   47.88,
   204.3833,
   168.9342,
   186.21320,
   163.17596, //Tyrosin
   99.13256,
   131.29,
   173.04,
   65.39,
   91.224,
 //kuenstliche Elemente:
   261.1087, //Rutherfordium, (61sec Halbwertszeit)
   262.1138, //Dubnium, 262 (34sec), 263 (27sec), 261 (1.8sec)
   263.1182, //Seaborgium
   262.1229, //Bohrium
   265.0, //Hassium, 265(1.5ms), 269(10s), 270 (22s)
   268.0, //Meitnerium, 2 Isotope 266 (3.4ms) und 268 (70ms Halbwertszeit)
   281.0, //Darmstadtium, 6 Isotope zwischen 269 (0.18ms) und 281 (66s)
   280.0, //Roentgenium, 6 Isotope, 272 (3.8ms) bis 280 (3.6s)

   285.0, //Copernicium, 3 Isotope, 277 (0.2ms), 283 (4s), 285 (34s)
   //hier koennen noch weitere Abkuerzungen eingefuegt werden
   0.0
  };

// fuer Isotope nur zweite Tabelle neu:
final static double mgtab_isoWert[] =
  {
    43.018375, //Acethyl (H3C-C=O)
    227.0278 , //Actinium
    106.90497,
    71.037095, //Alanin
    26.9815  , //Aluminium
    85.052745, //Aib
    126.05413, //Azidohomoalanin
    156.10108,
    39.96238,
    114.04289,
    115.026895,
    74.9216,
    243.0614,
    209.9871,
    196.9665,
    137.90501,
    9.01218,
    208.9804,
    247.0703,
    78.91835,
    101.060225, //Boc-Schutzgruppe
    91.054775, //Benzyl
    57.070425, //Butyl
    39.96259,
    113.90357,
    139.90528,
    251.0796,
    34.96885,
    247.0703,
    65.039125, // Cyclopentadienyl (C5H5)
    51.94051,
    132.9051,
    58.9332,
    62.9296,
    103.009165,
    162.5,
    167.26,
    252.0829,
    29.039125,
    151.965,
    55.93493,
    223.075875, //Fmoc-Schutzgruppe
    257.0951,
    223.0197,
    68.92568,
    157.25,
    73.92115,
    57.021445, //Glycine
    128.05854,
    129.042545,
    4.002604,
    179.94681,
    201.97063,
    164.9303,
    137.058885,
    113.084045,
    114.90407,
    192.96328,
    83.9115,
    138.90606,
    7.016005,
    260.1053,
    174.967,
    113.084045,
    128.09494,
    258.0986,
    131.040465,
    15.023475, //Methyl
    23.98505,
    54.938,
    97.90551,
    269.092565, /*Mz-Schutzgruppe*/
    269.092565, /*MZ-Schutzgruppe*/
    22.98977,
    92.90638,
    141.90748,
    19.99244,
    57.93534,
    259.1009,
    237.0482,
    191.96141,
    231.0359,
    253.089795, //Pbf-Schutzgruppe
    207.97664,
    105.9032,
    147.068395, //Phenylalanin
    77.039125, //Phenyl (C6H5)
    146.9151,
    208.9824,
    97.052745,
    140.9077,
    194.96482,
    244.0642,
    239.082015, //Pz-Schutzgruppe
    239.082015, //Pz-Schutzgruppe
    226.0254,
    84.91171,
    186.95596,
    102.9055,
    222.0176,
    101.07,
    120.90375,
    44.95591,
    87.031995,
    79.91651, //Selen
    27.9769,
    150.36,
    119.90213,
    87.90561,
    180.9479,
    158.9253,
    98.9063,
    129.9067,
    101.047645,
    232.0381,
    47.94795,
    204.97446,
    168.9342,
    186.07929,
    163.063295,
    99.068395,
    131.90416,
    173.93902,
    63.92915,
    89.90432,
 //kuenstliche Elemente:
    261.1087, //Rutherfordium, (61sec Halbwertszeit)
    262.1138, //Dubnium, 262 (34sec), 263 (27sec), 261 (1.8sec)
    263.1182, //Seaborgium
    262.1229, //Bohrium
    265.0, //Hassium, 265(1.5ms), 269(10s), 270 (22s)
    268.0, //Meitnerium, 2 Isotope 266 (3.4ms) und 268 (70ms Halbwertszeit)
    281.0, //Darmstadtium, 6 Isotope zwischen 269 (0.18ms) und 281 (66s)
    280.0, //Roentgenium, 6 Isotope, 272 (3.8ms) bis 280 (3.6s)
    285.0, //Copernicium, 3 Isotope, 277 (0.2ms), 283 (4s), 285 (34s)
    //hier koennen noch weitere Abkuerzungen eingefuegt werden
    0.0
  };

final static int ISO=1, DACH=2;

public static double mol_weight(String formel,String[] zs,int isoflag) // Berechne Molekulargewicht
{
 // Wenn isoflag gesetzt ist, werden nur haeufigste Isotope verwendet,
 // sonst wird das durchschnittliche Molekulargewicht berechnet.
 int c,klamzu;
 String s[]={null};
 double m, summe=0;

 //Die folgende Tabelle enthaelt alle Elemente welche mit nur einem Buchstaben abgekuerzt werden.
 final double einzelzeichen[]=
/* A */	{0, 10.811, 12.011, 2.014102, 0, 18.9984, 0, 1.00794, 126.9044,
/* J */	 126.9044, 39.0983, 0, 0, 14.0067, 15.9994, 30.9738, 0, 0,
/* S */	 32.066, 3.01605, 238.0289, 50.9415, 183.85, 0, 88.9059, 135.14238};
/* letzter Wert Z = Schutzgruppe C6H5-CH2-O-CO- */

 //das gleiche fuer Isotope:
 final double einzelzeichen_iso[]=
/* A */	{0, 11.0093, 12.000, 2.014102, 0, 18.9984, 0, 1.007825, 126.9044,
/* J */	 126.9044, 38.9637, 0, 0, 14.00307, 15.9949, 30.9738, 0, 0,
/* S */	 31.97207, 3.01605, 238.05076, 50.94398, 183.95099, 0, 88.90543, 135.044575};
/* letzter Wert Z = Schutzgruppe C6H5-CH2-O-CO- */
 //System.out.println("mol_weight('"+formel+"')"); //test

 while(isformelzeichen(c=formel.charAt(0)) && c!=')' && c!=']')
  {
   if(c=='(' || c=='[')
	{if(c=='[') klamzu=']'; else klamzu=')';
	 m=mol_weight(formel.substring(1),s,isoflag);
	 formel=s[0];
	 c=nextchar(formel); if(formel.length()>0) formel=formel.substring(1);
	 if(c!=klamzu && errorflag==0) fehler1("fehlende Klammer");
	 if(errorflag!=0) break;
	}
   else if(c=='^' && isdigit(formel.charAt(1)))
        {
	 //System.out.println("sterndach nach ^ aufgerufen");//test
	 m=sterndach(formel,s,isoflag|DACH);
	 formel=s[0];
	}
   else
    {if(!isupper(c))
		{fehler2("ungueltige Formel:",formel); break;}
     if(islower(formel.charAt(1)) ||
	(formel.charAt(1)=='Z' && (c=='P' || c=='M'))) //ist naechster Buchstabe ein Kleinbuchstabe, oder Ausnahmen PZ oder MZ?
      {int i,k;                                        //ja: Abkuerzung aus der Tabelle auslesen
       double[] zmgtabelleWert;
       if(isoflag==0) {zmgtabelleWert=mgtabelleWert;}
       else           {zmgtabelleWert=mgtab_isoWert;}
       for(i=0,m=0;mgtabelleSymbol[i]!=null;i++)
	{
	 if(mgtabelleSymbol[i].charAt(0)==c)
	  {k=mgtabelleSymbol[i].length();
	   //System.out.println("k="+" Vergleich: '"+mgtabelleSymbol[i]+"' mit '"+formel.substring(0,k)+"'");//test
	   if(mgtabelleSymbol[i].equals(formel.substring(0,k)))
	    {m=zmgtabelleWert[i]; formel=formel.substring(k); break;}
	  }
	}
       if(i==1) set_actinium_warnung(); //Fuer Warnung um nicht Acethyl mit Actinium zu verwechseln
      }
     else
      {m = (isoflag==0) ? einzelzeichen[c-'A'] : einzelzeichen_iso[c-'A'];   //nein: dann ist es ein Element, das mit nur einem Buchstaben abgekuerzt wird.
       if(m!=0) formel=formel.substring(1);
      }
    }
   if(m==0) {fehler2("Unbekannt:",formel); formel=formel.substring(1); break;}
   if(isdigit(formel.charAt(0)))
	{c = formel.charAt(0) - '0'; formel=formel.substring(1);
	 while(isdigit(formel.charAt(0)))
		{ c= 10*c + (int)formel.charAt(0) - '0'; formel=formel.substring(1);}
	}
   else c=1;
   summe += c*m;
   while(ist_leer(formel.charAt(0))) formel=formel.substring(1);
  }
 if(c=='*')
  {formel=formel.substring(1);
   if(isdigit(c=formel.charAt(0)))
	{c = formel.charAt(0) - '0'; formel=formel.substring(1);
	 while(isdigit(formel.charAt(0)))
		{ c= 10*c + formel.charAt(0) - '0'; formel=formel.substring(1);}
	}
   else if(c=='^')
	{//Trick: z.B. *^13C2 soll 2 schon gezaehlte C als 13C rechnen
	 //System.out.println("sterndach nach *^ aufgerufen");//test
	 summe += sterndach(formel,s,isoflag);
	 formel=s[0];
	 c=1;
	}
   else	c=1;
   summe += c*mol_weight(formel,s,isoflag);
   formel=s[0];
  }
 zs[0] = formel;
 //System.out.println("summe="+summe+"  *zs='"+zs[0]+"'"); //test
 return summe;
}

/******************* Erweiterung fuer Isotope ************************/
/*
 Beispiel: Boc-Ala-Gly-Ala*^13C-Aib-OMe sollte 417.464 (417.227) geben
           (nicht 429.47 (429.23) wie mit alter Version)
 z.B. *^13C2 soll 2 _schon_gezaehlte_ C als 13C rechnen
 (im Gegensatz zu ^13C2 (ohne *) wo das wirklich 2 zusaetzliche C sind)
 Spezialfall Deuterium: z.B. *^D12

 Die Funktion sterndach() soll als Formel etwas in der Form
 "^<Zahl><Atom><Zahl>..." bekommen. (Der Stern wurde schon verarbeitet).
 Als Rueckgabewert soll die Differenzmasse berechnet werden, also markiertes
 minus nicht markiertes. zs soll dann noch die Restformel zurueckgeben.
 Beispiele: ^18O, ^13C6, ^6Li, ^208Pb, ^2H11, ^D11
 Spezialfall Deuterium: statt ^2H11 sollte ^D11 benutzt werden (genauer weil
 Deuterium nicht 2.000 sondern 2.014102 hat).
*/
static double sterndach(String formel,String[] zs,int flags)
{
 String atom;
 String s[]={null};
 double summe,masse,alt;
 int c,k,anzahl;
 char ch;
 if(formel.charAt(0)!='^') fehler1("sterndach-Syntaxfehler");
 if(formel.charAt(1)=='D' || formel.charAt(1)=='T') //Spezialfall Deuterium u. Tritium
   {atom = formel.charAt(1) + "\0";
    masse=mol_weight(atom,s,0);
    atom = "H\0";
    k=2;
   }
 else //Normalfall
   {for(masse=0,k=1;(c=formel.charAt(k))!=0 && isdigit(c);k++)
          masse=10*masse+c-'0';
    if(masse<=1 || !isupper(formel.charAt(k))) fehler1("falsche Isotop-Syntax");
    atom = "" + formel.charAt(k++);
    ch=formel.charAt(k);
    if(islower(ch)) k++; else ch=0;
    atom = atom + ch + "\0";
   }
 for(anzahl=0;(c=formel.charAt(k))!=0 && isdigit(c);k++)
    anzahl=10*anzahl+c-'0';
 if(anzahl==0) anzahl=1;
 while(ist_leer(formel.charAt(k))) k++;
 zs[0] = formel.substring(k);
 alt = mol_weight(atom,s,flags&ISO);
 //System.out.println("sterndach Test auf falsches Isotop: alt="+alt+" masse="+masse);//test
 if(alt==0 || alt-masse>5 || masse-alt>5) fehler1("Falsches-Isotop");
 if((flags&DACH)!=0)
   summe = masse * anzahl;
 else
   summe = (masse - alt) * anzahl;
 //System.out.println("sterndach Rueckgabewert: "+summe);//test
 return summe;
}

/********************** Fehlermeldungen *************************/
static int errorflag=0, warnflag=0;
static int actinium_warnung=0; //fuer Warnung um Actinium nicht mit Acetyl zu verwechseln
//static char scratch[400],
static String errorstring=null, warningstring=null;

static void error_reset(String errstr,String warnstr)
{
 errorflag=0;
 actinium_warnung=0;
 errorstring=errstr;
 warningstring=warnstr;
}

static void fehler1(String text)
{
 //if(errorstring!=null) strcpy(errorstring,text);
 //else printf("%s\n",text);
 //System.out.println("Error: "+text);
 errorstring=text;
 errorflag++;
}

 static void fehler1s(String text,String p1)
{
 //Es sollte an der Stelle wo in text %s vorkommt p1 eingefuegt werden
 //errorstring=text+p1; //provisorisch
 int i = text.indexOf("%s");
 String s1 = text.substring(0,i);
 String s2 = text.substring(i+2,text.length());
 errorstring = s1+p1+s2;
 errorflag++;
}

static void fehler0(String text,int c)
{
 //sprintf(scratch,"%s %c",text,c);
 fehler1(text+" "+c);
}

static void fehler2(String text1,String text2)
{
 //sprintf(scratch,"%s%s",text1,text2);
 fehler1(text1+text2);
}

static void set_actinium_warnung() {actinium_warnung++;}
//static int  get_actinium_warnung() {return actinium_warnung;}

static void warnung1(String text)
{
 //if(warningstring!=null) strcpy(warningstring,text);
 warnflag=1;
 warningstring=text;
}

/*****************Erweiterung fuer Summenformeln *********************/
//#ifdef SUMMENFORMELN  //in Java geht ifdef nicht

/*
static String getsummenformel_pep(String peptid)
{
 int c=dreibuchstaben_auf_einbuchstaben_abkuerzung_reduzieren(peptid);
 return aminos_summenformel[c-'A']+"\0";
}
*/

static String getsymbol(String[] zs)  //Symbol auslesen und Zeiger zs entsprechend erhoehen
{
 //static char sym[8]; //Abkuerzungen sind hoechstens 4 Zeichen lang, 8 ist also ausreichend
 //char *p=sym;
 String sym;
 int i;
 char c;
 String s;
 s = zs[0];
 if(!isupper(s.charAt(0)))  //ist erstes Zeichen ein Grossbuchstabe?
          {return "\0";}    //nein: mit leerem String zurueckkehren
 //*p++ = c = *s++;  //erster Grossbuchstabe kopieren
 sym = s.substring(0,1); s=s.substring(1); //erster Grossbuchstabe kopieren
 i=1; c=sym.charAt(0); //bisher 1 Zeichen kopiert
 if((c=='P' || c=='M') && s.charAt(0)=='Z' && !islower(s.charAt(1))) //Ausnahmen PZ und MZ behandeln
   //{*p++ = *s++;}
  {sym += s.charAt(0); s=s.substring(1);}
 else
  while(s.length()>0 && (c=s.charAt(0))!=0 && islower(c))  //solange Kleinbuchstaben folgen
    {
     if(++i<8) {sym += c;}      //diese kopieren (aber maximal 8)
     s=s.substring(1);
    }
 sym += "\0";  //den String mit 0 abschliessen
 zs[0] = s;
 return sym;
}

static int getnumber(String[] zs)
{
 int c,z=0;
 String s;
 s = zs[0];
 //System.out.println("getnumber(zs[0]='"+s+"')");//test
 while(s.length()>0 && (c=s.charAt(0))!=0 && isdigit(c))
  {
   s=s.substring(1); //c = *s++;
   z=10*z+c-'0';
  }
 zs[0] = s;
 //System.out.println(" Reststring='"+s+"'  z="+z);//test
 return z;
}

final static String elemente[]= //Alle Elemente des Periodensystems bis zum Lr
 {"D","H","He", //Deuterium an Position 0, sonst ist Position jeweils Ordnungsnummer im Periodensystem
  "Li","Be","B", "C", "N", "O", "F", "Ne",
  "Na","Mg","Al","Si","P", "S", "Cl","Ar",
  "K", "Ca","Sc","Ti","V", "Cr","Mn","Fe","Co","Ni","Cu","Zn","Ga","Ge","As","Se","Br","Kr",
  "Rb","Sr","Y", "Zr","Nb","Mo","Tc","Ru","Rh","Pd","Ag","Cd","In","Sn","Sb","Te","I", "Xe",
  "Cs","Ba","La","Ce","Pr","Nd","Pm","Sm","Eu","Gd","Tb","Dy","Ho","Er","Tm","Yb","Lu","Hf",
                      "Ta","W", "Re","Os","Ir","Pt","Au","Hg","Tl","Pb","Bi","Po","At","Rn",
  "Fr","Ra","Ac","Th","Pa","U", "Np","Pu","Am","Cm","Bk","Cf","Es","Fm","Md","No","Lr", //Lr ist Element Nr=103
  "Rf","Db","Sg","Bh","Hs","Mt","Ds","Rg","Cn", //hier noch neue kuenstliche Elemente einfuegen (Cn ist Nr=112)
  "T", //zusaetzlich noch Tritium (Ordnungsnummer hier irrelevant)
  null
 };
//#define ANZAHLELEMENTE 114
final static int ANZAHLELEMENTE=114;

static String getelementsymbol(int nr)
{
 if(nr>=ANZAHLELEMENTE) return null;
 return elemente[nr];
}

static int strcmp(String a, String b)
{
 if(a.equals(b)) return 0;
 if(a.equals(b+"\0")) return 0;
 if(b.equals(a+"\0")) return 0;
 return -1;
}

static int elementnummer(String symbol)
{
 int nr;
 if(strcmp(symbol,"J")==0)
   symbol="I"; //Spezialfall: Jod mit 'J' abgekuerzt statt 'I'
 for(nr=0;elemente[nr]!=null;nr++)
   if(strcmp(symbol,elemente[nr])==0) return nr;
 return -1; //bei Fehler -1 zurueckgeben
}

//Alle Abkuerzungen, die keine Element und keine Standard-Aminsaeuren sind:
final static String summenformeltabelle[]=
 {
  "Ace", "C2H3O", //Acethyl (H3C-C=O)
  "Bzl", "C7H7",
  "Z",   "C8H7O2",
  "Boc", "C5H9O2",
  "Fmoc", "C15H11O2",
  "Me", "CH3",
  "Et", "C2H5",
  "Bu", "C4H9",
  "Ph", "C6H5",
  "PZ", "C14H11N2O2",
  "Pz", "C14H11N2O2",
  "MZ", "C15H13N2O3",
  "Mz", "C15H13N2O3",
  "Cp", "C5H5",
  "Pbf", "C13H17O3S",

  //hier koennen noch weitere Abkuerzungen eingefuegt werden
  null, null
 };

static char nextchar(String s)
{
 char c;
 if(s!=null && s.length()>0) c=s.charAt(0);
 else c=0;
 return c;
}
    static char overnextchar(String s)
    {
        char c;
        if(s!=null && s.length()>1) c=s.charAt(1);
        else c=0;
        return c;
    }

static String plusplus(String s)
{
 if(s==null || s.length()==0) return "\0";
 return s.substring(1);
}

static String strncpy(String quelle,int max)
{
 int k=quelle.length();
 if(k<max) max=k;
 return quelle.substring(0,max); //+"\0";
}

static int strlen(String s)
{
 int k=s.length();
 if(k>0 && s.charAt(k-1)==0) --k;
 return k;
}

static String getsummenformel(String formel,String[] zs)
{
 // falls zs nicht NULL ist, wird dort die Restformel gespeichert
 String s,sym,neu;
 String[] ts={null}; //temporaerer Zeiger auf String
 String summenformel="";
 int i,c,n,index,z,klamzu;
 int element[]=new int[120];
 int peptidmodus=0,knummer=0;
 for(i=0;i<120;i++) element[i]=0;
 //if(zs[0]==null) printf("getsummenformel('%s',NULL)\n",formel);//test
 //else printf("getsummenformel('%s',zs)\n",formel);//test
 while((c=nextchar(formel))!=0 && c!=')' && c!=']' && c!=',')
  {
   if(c=='~') {peptidmodus ^= 1; formel=formel.substring(1); continue;}
   if(ist_leer(c)) {formel=formel.substring(1); continue;}
   if(c=='^')
     {//Isotopmarkiertes Atom:
      //while((c= *++formel)!=0 && isdigit(c))  ;//provi. Isotopangaben ignorieren
      do
       {
	formel=formel.substring(1);
	c=nextchar(formel);
       }
      while (c!=0 && isdigit(c));   //provi. Isotopangaben ignorieren

      warnung1("Isotope werden nicht in der Summenformel eingefuegt");
      continue;
     }
   if(c=='*')
     {formel=formel.substring(1);
      if((c=nextchar(formel))=='^')  //Sterndach-Syntax ("*^") erkannt?
        {                    //ja: Isotop-Markierungen behandeln
	 String tmpstr;
	 if(formel.length()>1) c=formel.charAt(1); else c=0;
	 if(!isdigit(c))
	  {if(c=='D') ;//H durch D ersetzen
	   else if(c=='T') ;//H durch T ersetzen
	   else {tmpstr=strncpy(formel,4); fehler2("Syntaxerror: ",tmpstr);}
	  }

	 //while((c= *++formel)!=0 && isdigit(c))  ;//provi. Isotopangaben ignorieren
	 do
	  {
	   formel=formel.substring(1);
	   c=nextchar(formel);
	  }
	 while (c!=0 && isdigit(c));   //provi. Isotopangaben ignorieren

	 //sym=getsymbol(&formel); //provi. Isotop-Atom ignorieren
	 //ts[0]=formel; sym=getsymbol(ts); formel=ts[0]; //provi. Isotop-Atom ignorieren
	 ts[0]=formel; getsymbol(ts); formel=ts[0]; //provi. Isotop-Atom ignorieren
	 while(isdigit(nextchar(formel))) formel=formel.substring(1); //provi. auch Anzahl ignorieren
	 warnung1("Isotope werden nicht in der Summenformel eingefuegt");
	 continue;
        }
      else  //Wenn nach dem '*' kein '^' kommt, dann Kristallwasser-Syntax (z.B. Na2SO4*10H2O)
        {
	 //knummer = (isdigit(c)) ? getnumber(&formel) : 1;
	 if(isdigit(c)) {ts[0]=formel; knummer=getnumber(ts); formel=ts[0];} else knummer=1;
	 neu=getsummenformel(formel,ts);
	 formel=ts[0];
	}
     }
   else if(c=='(' || c=='[')
     {
      if(c=='(') klamzu=')'; else klamzu=']';
      neu=getsummenformel(formel.substring(1),ts);
      formel=ts[0];
      if(nextchar(formel)!=klamzu && errorflag==0) fehler1("Klammerfehler");
      if(formel!=null && formel.length()>0) formel=formel.substring(1);
      //printf("Summenformel vom Klammernteil='%s' Restformel='%s'\n",neu,formel);//test
     }
   else
     {
      String[] p; //Abkuerzungen *p;
      String stest=formel;
      ts[0]=formel; sym=getsymbol(ts); formel=ts[0];
      if(nextchar(sym)==0)
        {
          //fehler1("Fehler in getsummenformel() nach getsymbol()");
          fehler1s("wrong Symbol: %s in getsummenformel()", stest);
          return summenformel + "\0";
        }
      neu="";
      if(peptidmodus!=0 && strlen(sym)==1 && (c=sym.charAt(0))!=0 && isupper(c))
        {
	     //if(pflag) neu=aminos_mit_sg[c-'A'].summenformel;
	     //else
	     neu=aminos_summenformel[c-'A'];
        }
      else
        //for(p=(pflag)?aminos_mit_sg:aminos,i=0;i<sizeof(aminos)/sizeof(Abkuerzungen);i++,p++)
        for(p=aminos,i=0;p[i]!=null;i++)
	 {
	  //if(strcmp(sym,p->sym)==0) {neu=p->summenformel; break;}
	  if(strcmp(sym,p[i])==0) {neu=aminos_summenformel[i]; break;}
	 }
      if(neu==null || neu.length()<1 || neu.charAt(0)==0)
        {
	 //for(p=summenformeltabelle,i=0;i<sizeof(summenformeltabelle)/sizeof(Abkuerzungen);i++,p++)
	 for(p=summenformeltabelle, i=0; p[2*i] != null; i++)
           if(strcmp(sym, p[2*i]) == 0)
	      {
	       neu = p[2*i+1];  break;
	      }
	}
      if(neu==null || neu.length()<1 || neu.charAt(0)==0)
        neu=sym;
      //printf("Summenformel von aktuellem Symbol: '%s'\n",neu);//test
     }
   if(knummer!=0)            {index=knummer; knummer=0;}
   //else if(isdigit(*formel)) {index=getnumber(&formel);}
   else if(formel!=null && formel.length()>0 && isdigit(formel.charAt(0))) {ts[0]=formel; index=getnumber(ts); formel=ts[0];}
   else                               {index=1;}
   while(neu!=null && neu.length()>0 && neu.charAt(0)!=0)
    {
     ts[0]=neu; s=getsymbol(ts); neu=ts[0];
     if(s==null || s.charAt(0)==0) fehler2("Fehler in getsymbol(): ",neu);//test
     n = elementnummer(s);
     //z = (isdigit(*neu)) ? getnumber(&neu) : 1;
     if(neu.length()>0 && isdigit(neu.charAt(0)))
          {ts[0]=neu; z=getnumber(ts); neu=ts[0];}
     else
          {z=1;}
     if(n<0) fehler2("Unbekanntes Element: ",s);
     else    element[n] += z*index;
    }
  }
 if(zs!=null) zs[0]=formel;

 //aus der Liste der benutzten Elemente die Summenformel konstruieren:
 //char zahltext[40],*st;
 //int j;
 //for(st=summenformel,i=0,j=6;i<120 && j<400;i++)
 for(i=0;i<120;i++)
  {
   if(element[i]!=0)
    {
     sym=getelementsymbol(i);
     //while((c= *sym++)!=0) {*st++ = c; j++;}
     summenformel += sym; //statt while-Schlaufe in c
     if(element[i]>1)
      {//sprintf(zahltext,"%d",element[i]);
       //for(sym=zahltext;(c= *sym++)!=0;) {*st++ = c; j++;}
       summenformel += element[i];
      }
    }
  }
 summenformel += "\0";

 //provi. hier muesste die Summenformel noch alfabetisch nach Elementen sortiert werden
 summenformel=summesortieren(summenformel);

 return summenformel;
}

/** Summenformel sortieren: **/
static String getsymbolundzahl(String[] zs)   //z.B. 'Na2C15H27' --> sym="Na2" *zs="C15H27"
{
 //static char sym[40];
 //char *y=sym;
 String s,sym="";
 char c;
 s = zs[0]; //Zeiger vom zu lesenden String
 //*y++ = c = *s++;
 c=nextchar(s); s=plusplus(s);
 sym += c;
 if(c==0) return sym; //bei Aufruf mit leerem String auch wieder leerer String zurueckgeben
 //while((c= *s++)!=0 && !isupper(c))
 for(;;)
  {
   c=nextchar(s);
   if(c==0 || isupper(c)) break;
   //*y++ = c;
   s=plusplus(s);
   sym += c;
  }
 //--s; //zuviel gelesenes zurueckstellen
 //*y=0;
 zs[0] = s; //erhoehter Zeiger speichern
 return sym;
}

static String einsortieren(String puffer,String sym)
{
 int c,gross,klein=0;
 String pufferstart=puffer;
 int i;
 gross = nextchar(sym); //erster Buchstabe muss ein Grossbuchstabe sein
 if(sym.length()>1) klein = sym.charAt(1); //weiterer kann ein Kleinbuchstabe sein
 if(!islower(klein)) klein=0; //falls nicht: auf 0 setzen
 for(i=0;nextchar(puffer)!=0;)
  {
   c = nextchar(puffer); //Erstes Zeichen der bisherigen Formel
   if(c==0)              //sind wir am Ende des Puffers?
     {//while((*puffer++ = *sym++)!=0) ; //ja: hier hineinkopieren, inklusive 0-Zeichen
      return pufferstart+sym;
     }
   if(c > gross || (c==gross && overnextchar(puffer)>klein)) //ist aktuelles Symbol weiter hinten im Alfabet?
     {//einfuegen(puffer,sym);                     //ja: neues Symbol hier einfuegen
      if(i==0) return sym+pufferstart; 
      return pufferstart.substring(0,i)+sym+pufferstart.substring(i);
     }
   //while((c= *++puffer)!=0 && !isupper(c)) ;  //neues Symbol im Puffer suchen
   for(;;) //neues Symbol im Puffer suchen
    {
     puffer=plusplus(puffer); i++;
     if((c=nextchar(puffer))==0 || isupper(c)) break;
    }
  }
 return pufferstart+sym;
}

static String summesortieren(String summenformel)
{
 String s1,s2;
 String sym;
 String[] ts={null}; //temporaerer Zeiger auf String
 //char *puffer=(char*)malloc(strlen(summenformel)+1);
 s1=summenformel;
 s2="";
 while(nextchar(s1)!=0)
  {
   ts[0]=s1; sym=getsymbolundzahl(ts); s1=ts[0];
   if(nextchar(sym)==0) {fehler2("Fehler in summesortieren() s1=",s1); return "\0";}
   s2=einsortieren(s2,sym);
  }
 //strcpy(summenformel,puffer); free(puffer);
 return s2;
}
/** Ende summesortieren **/

/** Ende Summenformeln-Berechnung **/

}
