package ch.rolfp.mgrechner;

import android.app.Activity;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

/**
 * Activity for Loading and Saving examples
 */
public class MyMenuActivity extends Activity implements View.OnClickListener {

    private static EditText nameToLoad, nameToSave, nameToDelete;
    private static TextView textViewFormel, textViewStatus;
    private static String justDeleted="", justDeletedName="";
    private static int loadNr=0, loadNrDirection=0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_mymenu);
        textViewFormel = (TextView)findViewById(R.id.textViewAktuelleFormel);
        textViewFormel.setText(MainActivity.getEingegebeneFormel());
        nameToLoad = (EditText)findViewById(R.id.editTextNameToLaod);
        nameToSave = (EditText)findViewById(R.id.editTextNameToSave);
        nameToDelete = (EditText)findViewById(R.id.editTextNameToDelete);
        Button buttonSave = (Button)findViewById(R.id.buttonSave);
        buttonSave.setOnClickListener(this);
        Button buttonLoad = (Button)findViewById(R.id.buttonLoad);
        buttonLoad.setOnClickListener(this);
        Button buttonDele = (Button)findViewById(R.id.buttonDelete);
        buttonDele.setOnClickListener(this);
        Button buttonUndo = (Button)findViewById(R.id.buttonUndo);
        buttonUndo.setOnClickListener(this);
        textViewStatus = (TextView)findViewById(R.id.textViewStatus);
        findSaveName();
    }

    private void findSaveName() {
        SharedPreferences pref=getSharedPreferences("MGRECHNER", 0);
        int i;
        String saveName;
        for(i=1;;i++) {
            saveName ="name"+i;
            if(pref.getString(saveName,"").length()==0) break;
        }
        CharSequence name= saveName;
        nameToSave.setHint(name);
        if(i>1) {name="name"+(i-1); loadNrDirection=0; loadNr=i-1;}
        else    {name="name1";      loadNrDirection=1; loadNr=1;}
        nameToLoad.setHint(name);
        nameToDelete.setHint(name);
    }

    private boolean findFirstLoadName(int istart) {
        SharedPreferences pref=getSharedPreferences("MGRECHNER", 0);
        int i;
        String string="";
        for(i=istart;i<100;i++) {
            string = "name"+i;
            if(pref.getString(string,"").length()>0) break;
        }
        if(i<100) {
            nameToLoad.setHint(string);
            loadNr=i;
            return true;
        }
        return false;
    }

    private boolean findLastLoadName(int istart) {
        SharedPreferences pref=getSharedPreferences("MGRECHNER", 0);
        int i;
        String string="";
        for(i=istart;i>0;--i) {
            string = "name"+i;
            if(pref.getString(string,"").length()>0) break;
        }
        if(i>0) {
            nameToLoad.setHint(string);
            loadNr=i;
            return true;
        }
        return false;
    }

    @Override
    public void onClick(View v) {
        String name,frm;
        boolean hintFlag;
        SharedPreferences pref=getSharedPreferences("MGRECHNER", 0);
        SharedPreferences.Editor editor;
        switch(v.getId()) {
            case R.id.buttonSave:
                name = nameToSave.getText().toString(); if(name.length()==0) name=nameToSave.getHint().toString();
                editor=pref.edit();
                editor.putString(name, MainActivity.getEingegebeneFormel());
                editor.apply();
                //textViewStatus.setText(name + " saved");
                frm=getString(R.string.frm_saved);
                textViewStatus.setText(String.format(frm,name));
                break;
            case R.id.buttonLoad:
                name = nameToLoad.getText().toString();
                if(name.length()==0) {name=nameToLoad.getHint().toString(); hintFlag=true;}
                else hintFlag=false;
                String string=pref.getString(name,"");
                if(string.length()>0) {
                    textViewFormel.setText(string);
                    MainActivity.setEingegebeneFormel(string);
                    //textViewStatus.setText(name+" loaded");
                    frm=getString(R.string.frm_loaded);
                    textViewStatus.setText(String.format(frm,name));
                    if(hintFlag) {
                        if (loadNrDirection == 0) {
                            if (loadNr<2 || !findLastLoadName(loadNr - 1))
                               {loadNrDirection = 1; findFirstLoadName(loadNr+1);}
                        } else {
                            if (!findFirstLoadName(loadNr + 1)) {
                                loadNrDirection = 0;
                                if(loadNr>1) findLastLoadName(loadNr-1);
                                else findLastLoadName(1);
                            }
                        }
                    }
                } else {
                    //textViewFormel.setText(name+" not found");
                    frm=getString(R.string.frm_notfound);
                    textViewFormel.setText(String.format(frm,name));
                }
                break;
            case R.id.buttonDelete:
                name = nameToDelete.getText().toString(); if(name.length()==0) name=nameToDelete.getHint().toString();
                if(name.length()>0) {
                    justDeleted = pref.getString(name,"");
                    if(justDeleted.length()==0) {
                        //textViewStatus.setText(name+" not found");
                        frm=getString(R.string.frm_notfound);
                        textViewStatus.setText(String.format(frm,name));
                        justDeleted=justDeletedName="";
                    } else {
                        justDeletedName = name;
                        editor = pref.edit();
                        editor.remove(name);
                        editor.apply();
                        textViewStatus.setText(justDeletedName + ": " + justDeleted + " deleted");
                        findSaveName();
                    }
                } else {
                    textViewStatus.setText("not deleted");
                }
                break;
            case R.id.buttonUndo:
                if(justDeleted.length()>0 && justDeletedName.length()>0) {
                    editor=pref.edit();
                    editor.putString(justDeletedName,justDeleted);
                    editor.apply();
                    textViewStatus.setText(justDeleted+" undeleted");
                    justDeleted=justDeletedName="";
                    findSaveName();
                } else {
                    textViewStatus.setText("nothing to undo");
                }
                break;
            default:
                break;
        }
    }

    /*
    private int getNumber(String name) {
        int number=0,i,imax=name.length(),c;
        for(i=0;i<imax && !MainActivity.isdigit(name.charAt(i));) i++;
        for(;i<imax && MainActivity.isdigit(c = name.charAt(i));i++) number=number*10+c-'0';
        return number;
    }
    */
}
