package ch.rolfp.mgrechner;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

public class ReactionsActivity extends Activity implements View.OnClickListener, AdapterView.OnItemSelectedListener {

    static EditText editText2,editText3,editText4;
    static int linkerNr=0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_reactions);
        editText2 = (EditText) findViewById(R.id.editText2);
        editText3 = (EditText) findViewById(R.id.editText3);
        editText4 = (EditText) findViewById(R.id.editText4);
        String str=MainActivity.getEingegebeneFormel();
        if(str.length()>0) {
            if (str.charAt(0) == '~') str = "H" + str;
            if (str.charAt(str.length() - 1) == '~') str += "OH";
        }
        editText2.setText(str);
        Button button=(Button)findViewById(R.id.button6);
        button.setOnClickListener(this);
        Spinner spinner = (Spinner)findViewById(R.id.spinner);
        ArrayAdapter adapter=ArrayAdapter.createFromResource(this,R.array.linkerName,android.R.layout.simple_spinner_item);
        spinner.setAdapter(adapter);
        spinner.setOnItemSelectedListener(this);
    }

    @Override
    public void onClick(View v) {
        double mg1,mg2,mg3, mg1i,mg2i,mg3i;
        String edukt1,edukt2,abgang,resultat1,resultat2;
        String sum1,sum2,sum3;
        TextView textOutput1=(TextView)findViewById(R.id.textViewResult1);
        TextView textOutput2=(TextView)findViewById(R.id.textViewResult2);
        TextView textOutput3=(TextView)findViewById(R.id.textViewSum);
        TextView textOutputWarn=(TextView)findViewById(R.id.textViewWarnings);
        EditText editTextEdukt1 = (EditText) findViewById(R.id.editText2);
        EditText editTextEdukt2 = (EditText) findViewById(R.id.editText4);
        EditText editTextAbgang = (EditText) findViewById(R.id.editText3);
        edukt1 = editTextEdukt1.getText().toString(); if(istleer(edukt1)) edukt1=" ";
        edukt2 = editTextEdukt2.getText().toString(); if(istleer(edukt2)) edukt2=" ";
        abgang = editTextAbgang.getText().toString(); if(istleer(abgang)) abgang=" ";
        if(isdigit(edukt1.charAt(0))) edukt1 = "*"+edukt1;
        if(isdigit(edukt2.charAt(0))) edukt2 = "*"+edukt2;
        if(isdigit(abgang.charAt(0))) abgang = "*"+abgang;
        error_reset();
        mg1 = calc_mol_weight(edukt1, false); mg2 = calc_mol_weight(edukt2, false); mg3 = calc_mol_weight(abgang, false);
        if(errorflag==0) {
            mg1i = calc_mol_weight(edukt1, true); sum1=textSummenFormel;
            mg2i = calc_mol_weight(edukt2, true); sum2=textSummenFormel;
            mg3i = calc_mol_weight(abgang, true); sum3=textSummenFormel;
            resultat1 = String.format("%.4f", mg1 + mg2 - mg3);
            resultat2 = String.format("%.4f", mg1i + mg2i - mg3i);
            //test:
            String sum4,sum5;
            calc_mol_weight(sum1+sum2,false);
            sum4=textSummenFormel;
            //Log.d("Testpunkt","sum4=sum1+sum2="+sum4);
            sum5=summenformelsubtrahieren(sum4,sum3);
            //Log.d("Testpunkt","sum4-sum3="+sum5);
            textOutput3.setText(sum5);
        } else {
            resultat1=""; resultat2="";
        }
        textOutput1.setText(resultat1);
        textOutput2.setText(resultat2);
        if(errorflag!=0) textOutputWarn.setText(errorstring);
        else if(!istleer(warningstring)) textOutputWarn.setText(warningstring);
        else textOutputWarn.setText("");
    }

    static String summenformelsubtrahieren(String s1,String s2) {
        char[] str1 = stringToChar(s1);
        char[] str2 = stringToChar(s2);
        char[] ziel = new char[s1.length() + 4]; //eigentlich sollte +1 reichen!?
        int i, j, k=0, n1, n2;
        //Beispiel: str1="C2H6O" str2="H2O" --> ziel="C2H4"
        for (i = j = 0; str1[i] != 0; ) {
            if (isupper(str1[i]) && !islower(str1[i + 1])) //Element mit 1-Buchstaben-Abkuerzung
            {
                if (isupper(str2[j]) && !islower(str2[j + 1]) && str2[j] == str1[i]) //identisch mit zu subtrahierendem?
                {
                    if (isdigit(str1[i+1])) n1 = getZahl(str1,i+1);
                    else n1 = 1;
                    if (isdigit(str2[j+1])) n2 = getZahl(str2,j+1);
                    else n2 = 1;
                    if (n2 > n1) fehler1("Error: cant subtract " + str2[j]);
                    if (n2 < n1) {
                        ziel[k++] = str1[i];
                        if(n1-n2>1) {
                            char[] z = intToCstring(n1 - n2);
                            for (int m = 0; z[m] != 0; m++) ziel[k++] = z[m];
                        }
                    }
                    j += 1; //naechstes Element im zu subtrahierenden Cstring
                    while (isdigit(str2[j])) j++;
                } else //sonst Elemnt von str1 uebernehmen
                {
                    ziel[k++] = str1[i];
                    for (int m = i+1; isdigit(str1[m]); ) ziel[k++] = str1[m++];
                }
                i += 1; //naechstes Element im ersten Cstring
                while (isdigit(str1[i])) i++;
            } else //sonst Element mit 2-Buchstaben-Abkuerzung
            {
                if (str2[j] == str1[i] && str2[j + 1] == str1[i + 1]) //identisch mit zu subtrahierendem?
                {
                    if (isdigit(str1[i+2])) n1 = getZahl(str1,i+2);
                    else n1 = 1;
                    if (isdigit(str2[j+2])) n2 = getZahl(str2,j+2);
                    else n2 = 1;
                    if (n2 > n1) fehler1("Error: cant subtract " + str2[j] + str2[j+1]);
                    if (n2 < n1) {
                        ziel[k++] = str1[i];
                        ziel[k++] = str1[i+1];
                        if(n1-n2>1) {
                            char[] z = intToCstring(n1 - n2);
                            for (int m = 0; z[m] != 0; m++) ziel[k++] = z[m];
                        }
                    }
                    j += 2; //naechstes Element im zu subtrahierenden Cstring
                    while (isdigit(str2[j])) j++;
                } else //sonst Elemnt von str1 uebernehmen
                {
                    ziel[k++] = str1[i];
                    ziel[k++] = str1[i + 1];
                    for (int m = i+2; isdigit(str1[m]); ) ziel[k++] = str1[m++];
                }
                i += 2; //naechstes Element
                while (isdigit(str1[i])) i++;
            }
        } //Ende for
        if (str2[j] != 0) fehler1("Error: cant subtract " + charToString2(str2, j));
        ziel[k]=0;
        return charToString(ziel);
    }

    //static boolean isletter(char c) {return (c>='A' && c<='Z')||(c>='a' && c<='z');}
    static boolean isupper(char c) {return (c>='A' && c<='Z');}
    static boolean islower(char c) {return (c>='a' && c<='z');}

    static char[] intToCstring(int n) {
        char[] ch = new char[12];
        int i = 12, j = 0;
        if (n < 0) ch[j++] = '-';
        while (n > 0 && i > 1) {
            ch[--i] = (char) (n % 10 + '0');
            n /= 10;
        }
        while (i < 12) ch[j++] = ch[i++];
        ch[j] = 0;
        return ch;
    }

    static int getZahl(char[] ch, int j) {
     int n=0;
     for(;isdigit(ch[j]);j++) n=10*n+ch[j]-'0';
     return n;
    }

    static char[] stringToChar(String s) {
        int i, imax = (s == null) ? 0 : s.length();
        char[] ch = new char[imax + 1];
        for (i = 0; i < imax; i++) {
            ch[i] = s.charAt(i);
        }
        ch[i] = 0;
        return ch;
    }

    static String charToString(char[] ch) {
        int i;
        String string = "";
        for (i = 0; ch[i] != 0; i++) string += ch[i];
        return string;
    }

    static String charToString2(char[] ch,int j) {
        int i;
        String string="";
	    for(i=j;ch[i]!=0;i++)  string += ch[i];
        return string;
    }

    static boolean isdigit(char c)
    {
      return (c>='0' && c<='9');
    }

    static boolean istleer(String s)
    {
        return (s==null || s.length()==0 || s.charAt(0)==0);
    }

    static String textNormierteFormel;
    static String textSummenFormel;

    static double calc_mol_weight(String formel,boolean isoflag)
    {
        String s[]={null}; //Zeiger auf einen String
        double result=0;
        int n;
        //error_reset(null,null);
        formel += "\0";
        textNormierteFormel=MainActivity.formel_normieren(formel, formel.length());
        textSummenFormel = MainActivity.getsummenformel(textNormierteFormel, null);
        n=MainActivity.klammertest(textNormierteFormel);
        if(n<0)
            fehler1("missing ( or [");
        else if(n>0)
            fehler1("missing ) or ]");
        else
        {
            result=MainActivity.mol_weight(textNormierteFormel, s, isoflag ? 1 : 0);
            //if(actinium_warnung>0) warnung1("Hinweis: Ac = Actinium, Ace = Acetyl");
            if(!istleer(MainActivity.errorstring)) {errorstring=MainActivity.errorstring; errorflag++;}
            if(!istleer(MainActivity.warningstring)) warningstring=MainActivity.warningstring;
        }
        return result;
    }

    @Override
    public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        linkerNr=position;
        if(position>0) {
            editText4.setText(linkerFormeln[position-1]);
            editText3.setText(linkerAbgang[position-1]);
        }
        else {
            editText4.setText("");
            editText3.setText("");
        }
    }

    @Override
    public void onNothingSelected(AdapterView<?> parent) {
    }

    final static String[] linkerFormeln = {
            "ICH2-CO-NH-C6H4-N=N-C6H4-NH-CO-CH2I",
            "ClCH2-CO-NH-C6H3(SO3H)-N=N-C6H3(SO3H)-NH-CO-CH2Cl",
            "ClCH2-CO-NH-C6H2Cl2-N=N-C6H2Cl2-NH-CO-CH2Cl"
    };

    final static String[] linkerAbgang = {
            "2HI",
            "2HCl",
            "2HCl"
    };

    static String errorstring=null, warningstring=null;
    static int errorflag=0;

    static void error_reset()
    {
        MainActivity.error_reset(null,null);
        errorflag=0;
        errorstring="";
        warningstring="";
    }

    static void fehler1(String text)
    {
        errorstring = text;
        errorflag++;
    }

}
